package wb;

import java.util.*;
import javax.servlet.http.*;
import javax.servlet.*;

/**
 * @author miya
 */
public class BattleManager{

	public static String ATTR_NAME = "BATTLE_MANAGER";

	private List words = new ArrayList();


	private BattleManager(){
	}

	public List getWords(){
		return words;
	}


	public static BattleManager getInstance(HttpServletRequest req){
		ServletContext ctx = req.getSession(true).getServletContext();
		return createInstance(ctx);
	}



	public static BattleManager createInstance(ServletContext ctx){
		BattleManager manager = (BattleManager)ctx.getAttribute(ATTR_NAME);
		if(manager == null){
			manager = new BattleManager();
			ctx.setAttribute(ATTR_NAME, manager);
		}		
		return manager;
	}


	public boolean isDuplicateWord(Word word){
		for(int i=0; i<words.size(); i++){
			Word compWord = (Word)words.get(i);
			if(compWord.getWord().equals(word.getWord())){
				return true;
			}
		}
		return false;		
	}


	public int battle(Word word) {
		
		int score = calcScore(word.getWord());
		word.setScore(score);
		

		for(int i=0; i<words.size(); i++){
			Word compWord = (Word)words.get(i);
			if(compWord.getScore() < score){
				words.add(i, word);
				return (i+1);
			}
		}
		
		words.add(word);
		return words.size();
	}



	private int calcScore(String word){
		
		int total = 0;
		for(int i=0; i<word.length(); i++){
			char c = word.charAt(i);
			total += c * (i+1);
		}

		int score = total % 1000;

		return score;		
	}

}
